zoukankan      html  css  js  c++  java
  • (约瑟夫应用)5.4.1 Roman Roulette

    Description


     Roman Roulette 

    The historian Flavius Josephus relates how, in the Romano-Jewish conflict of 67 A.D., the Romans took the town of Jotapata which he was commanding. Escaping, Jospehus found himself trapped in a cave with 40 companions. The Romans discovered his whereabouts and invited him to surrender, but his companions refused to allow him to do so. He therefore suggested that they kill each other, one by one, the order to be decided by lot. Tradition has it that the means for effecting the lot was to stand in a circle, and, beginning at some point, count round, every third person being killed in turn. The sole survivor of this process was Josephus, who then surrendered to the Romans. Which begs the question: had Josephus previously practised quietly with 41 stones in a dark corner, or had he calculated mathematically that he should adopt the 31st position in order to survive?

    Having read an account of this gruesome event you become obsessed with the fear that you will find yourself in a similar situation at some time in the future. In order to prepare yourself for such an eventuality you decide to write a program to run on your hand-held PC which will determine the position that the counting process should start in order to ensure that you will be the sole survivor.

    In particular, your program should be able to handle the following variation of the processes described by Josephus. n > 0 people are initially arranged in a circle, facing inwards, and numbered from 1 to n. The numbering from 1 to n proceeds consecutively in a clockwise direction. Your allocated number is 1. Starting with person number i, counting starts in a clockwise direction, until we get to person number k (k > 0), who is promptly killed. We then proceed to count a further k people in a clockwise direction, starting with the person immediately to the left of the victim. The person number k so selected has the job of burying the victim, and then returning to the position in the circle that the victim had previously occupied. Counting then proceeds from the person to his immediate left, with the kth person being killed, and so on, until only one person remains.

    For example, when n = 5, and k = 2, and i = 1, the order of execution is 2, 5, 3, and 1. The survivor is 4.

    Input and Output

    Your program must read input lines containing values for n and k (in that order), and for each input line output the number of the person with which the counting should begin in order to ensure that you are the sole survivor. For example, in the above case the safe starting position is 3. Input will be terminated by a line containing values of 0 for n and k.

    Your program may assume a maximum of 100 people taking part in this event.

    Sample Input

    1 1
    1 5
    0 0

    Sample Output

    1
    1

    这道题和约瑟夫问题十分像,就是简单的加了一个埋人,但是思路却有些不同,这道题是从加了一个循环,查找是不是剩下的是第一个(即查找当前开始的杀人剩下的不是1号)

    因为这道题的数据量不是很大,所以算法没有进行优化

    注意不能是自己埋自己即下面————————

    #include<iostream>
    #include <algorithm>
    using namespace std;
    int main()
    {
     int m,n,p=0,q,i,a[105],count,x;
     while(cin>>m>>n&&m!=0&&n!=0)
     {
      for(i=1;i<=m;i++)
       a[i]=i;  
      int ex=m;
      for(x=1;x<=m;x++)
      {  
               for(i=1;i<=m;i++)
       a[i]=i;
       i=x;
       while(ex>1)
       {
        count=0;
        while(1)//i-1 是要找的
        {
         if(a[i]!=0)
          count++;
         if(count==n)
          break;
         i++;
         if(i>m)
          i=1;
        }
        //cout<<a[i]<<"被杀掉";
        a[i]=0;//////— — — — — — — — — — — — — — — — — — — — — — — — — — — — — —这里必须进行初始化,要不然会出现自己埋自己的情形

        p=i+1;
        if(p>m)
         p=1;
        count=0;
        while(1)//i-1 是要找的
        {
         if(a[p]!=0)
          count++;
         if(count==n)
          break;
         p++;
         if(p>m)
          p=1;      
        }
       // cout<<':'<<p<<endl;
       // cout<<i<<endl;
        a[i]=a[p];
        a[p]=0;
        ex--;
        i++;///////此处加1不可少,要不然就错了
        if(i>m)
         i=1;
       // for(int j=1;j<=m;j++)
            // cout<<j<<' '<<a[j]<<endl;
       }
       for(i=1;i<=m;i++)
        if(a[i]!=0&&a[i]==1)
         cout<<x<<endl;
        //cout<<"*********************"<<endl;
        ex=m;
      }
     }
     return 0;
    }

  • 相关阅读:
    LeetCode 130. 被围绕的区域 (DFS)
    LeetCode 200. 岛屿数量 (BFS)
    LeetCode 200. 岛屿数量 (DFS)
    Win10下Anaconda命令行相关操作
    LeetCode 53. 最大子序和
    从尾到头打印链表
    字符串逆序
    交换俩字符串
    LeetCode 147. 对链表进行插入排序
    LeetCode 面试题 02.08. 环路检测
  • 原文地址:https://www.cnblogs.com/zswbky/p/5432118.html
Copyright © 2011-2022 走看看